Index: drivers/filesystems/btrfs/fileinfo.c
===================================================================
--- drivers/filesystems/btrfs/fileinfo.c	(révision 75772)
+++ drivers/filesystems/btrfs/fileinfo.c	(copie de travail)
@@ -3736,274 +3187,309 @@
 
                 ir = (INODE_REF*)tp.item->data;
 
-                hl = ExAllocatePoolWithTag(PagedPool, sizeof(hardlink), ALLOC_TAG);
-                if (!hl) {
-                    ERR("out of memory\n");
-                    free_fcb(fcb);
-                    return STATUS_INSUFFICIENT_RESOURCES;
-                }
-                
-                hl->parent = tp.item->key.offset;
-                hl->index = ir->index;
-                
-                hl->utf8.Length = hl->utf8.MaximumLength = ir->n;
-                
-                if (hl->utf8.Length > 0) {
-                    hl->utf8.Buffer = ExAllocatePoolWithTag(PagedPool, hl->utf8.MaximumLength, ALLOC_TAG);
-                    RtlCopyMemory(hl->utf8.Buffer, ir->name, ir->n);
-                }
-                
+                parent = tp.item->key.offset;
+
                 Status = RtlUTF8ToUnicodeN(NULL, 0, &stringlen, ir->name, ir->n);
                 if (!NT_SUCCESS(Status)) {
                     ERR("RtlUTF8ToUnicodeN 1 returned %08x\n", Status);
-                    ExFreePool(hl);
-                    free_fcb(fcb);
+                    free_fcb(Vcb, fcb);
                     return Status;
                 }
-                
-                hl->name.Length = hl->name.MaximumLength = stringlen;
-                
+
+                name.Length = name.MaximumLength = (UINT16)stringlen;
+
                 if (stringlen == 0)
-                    hl->name.Buffer = NULL;
+                    name.Buffer = NULL;
                 else {
-                    hl->name.Buffer = ExAllocatePoolWithTag(PagedPool, hl->name.MaximumLength, ALLOC_TAG);
-                    
-                    if (!hl->name.Buffer) {
+                    name.Buffer = ExAllocatePoolWithTag(PagedPool, name.MaximumLength, ALLOC_TAG);
+
+                    if (!name.Buffer) {
                         ERR("out of memory\n");
-                        ExFreePool(hl);
-                        free_fcb(fcb);
+                        free_fcb(Vcb, fcb);
                         return STATUS_INSUFFICIENT_RESOURCES;
                     }
-                    
-                    Status = RtlUTF8ToUnicodeN(hl->name.Buffer, stringlen, &stringlen, ir->name, ir->n);
+
+                    Status = RtlUTF8ToUnicodeN(name.Buffer, stringlen, &stringlen, ir->name, ir->n);
                     if (!NT_SUCCESS(Status)) {
                         ERR("RtlUTF8ToUnicodeN 2 returned %08x\n", Status);
-                        ExFreePool(hl->name.Buffer);
-                        ExFreePool(hl);
-                        free_fcb(fcb);
+                        ExFreePool(name.Buffer);
+                        free_fcb(Vcb, fcb);
                         return Status;
                     }
+
+                    hl_alloc = TRUE;
                 }
-                    
-                InsertTailList(&fcb->hardlinks, &hl->list_entry);
             } else if (tp.item->key.obj_type == TYPE_INODE_EXTREF) {
                 INODE_EXTREF* ier;
-                hardlink* hl;
                 ULONG stringlen;
 
                 ier = (INODE_EXTREF*)tp.item->data;
-                
-                hl = ExAllocatePoolWithTag(PagedPool, sizeof(hardlink), ALLOC_TAG);
-                if (!hl) {
-                    ERR("out of memory\n");
-                    free_fcb(fcb);
-                    return STATUS_INSUFFICIENT_RESOURCES;
-                }
-                
-                hl->parent = ier->dir;
-                hl->index = ier->index;
-                
-                hl->utf8.Length = hl->utf8.MaximumLength = ier->n;
-                
-                if (hl->utf8.Length > 0) {
-                    hl->utf8.Buffer = ExAllocatePoolWithTag(PagedPool, hl->utf8.MaximumLength, ALLOC_TAG);
-                    RtlCopyMemory(hl->utf8.Buffer, ier->name, ier->n);
-                }
-                
+
+                parent = ier->dir;
+
                 Status = RtlUTF8ToUnicodeN(NULL, 0, &stringlen, ier->name, ier->n);
                 if (!NT_SUCCESS(Status)) {
                     ERR("RtlUTF8ToUnicodeN 1 returned %08x\n", Status);
-                    ExFreePool(hl);
-                    free_fcb(fcb);
+                    free_fcb(Vcb, fcb);
                     return Status;
                 }
-                
-                hl->name.Length = hl->name.MaximumLength = stringlen;
-                
+
+                name.Length = name.MaximumLength = (UINT16)stringlen;
+
                 if (stringlen == 0)
-                    hl->name.Buffer = NULL;
+                    name.Buffer = NULL;
                 else {
-                    hl->name.Buffer = ExAllocatePoolWithTag(PagedPool, hl->name.MaximumLength, ALLOC_TAG);
-                    
-                    if (!hl->name.Buffer) {
+                    name.Buffer = ExAllocatePoolWithTag(PagedPool, name.MaximumLength, ALLOC_TAG);
+
+                    if (!name.Buffer) {
                         ERR("out of memory\n");
-                        ExFreePool(hl);
-                        free_fcb(fcb);
+                        free_fcb(Vcb, fcb);
                         return STATUS_INSUFFICIENT_RESOURCES;
                     }
-                    
-                    Status = RtlUTF8ToUnicodeN(hl->name.Buffer, stringlen, &stringlen, ier->name, ier->n);
+
+                    Status = RtlUTF8ToUnicodeN(name.Buffer, stringlen, &stringlen, ier->name, ier->n);
                     if (!NT_SUCCESS(Status)) {
                         ERR("RtlUTF8ToUnicodeN 2 returned %08x\n", Status);
-                        ExFreePool(hl->name.Buffer);
-                        ExFreePool(hl);
-                        free_fcb(fcb);
+                        ExFreePool(name.Buffer);
+                        free_fcb(Vcb, fcb);
                         return Status;
                     }
+
+                    hl_alloc = TRUE;
                 }
-                
-                InsertTailList(&fcb->hardlinks, &hl->list_entry);
+
             }
         }
+    } else {
+        hardlink* hl = CONTAINING_RECORD(fcb->hardlinks.Flink, hardlink, list_entry);
+
+        name = hl->name;
+        parent = hl->parent;
     }
-    
-    if (IsListEmpty(&fcb->hardlinks)) {
+
+    if (parent == 0) {
         ERR("subvol %llx, inode %llx has no hardlinks\n", subvol->id, inode);
-        free_fcb(fcb);
-        return STATUS_INTERNAL_ERROR;
+        free_fcb(Vcb, fcb);
+        if (hl_alloc) ExFreePool(name.Buffer);
+        return STATUS_INVALID_PARAMETER;
     }
-    
-    hl = CONTAINING_RECORD(fcb->hardlinks.Flink, hardlink, list_entry);
-    
-    // FIXME - does this work with subvols?
-    
-    if (hl->parent == inode) // root of subvol
-        parfr = NULL;
-    else {
-        Status = open_fileref_by_inode(Vcb, subvol, hl->parent, &parfr, Irp);
+
+    if (parent == inode) { // subvolume root
+        KEY searchkey;
+        traverse_ptr tp;
+
+        searchkey.obj_id = subvol->id;
+        searchkey.obj_type = TYPE_ROOT_BACKREF;
+        searchkey.offset = 0xffffffffffffffff;
+
+        Status = find_item(Vcb, Vcb->root_root, &tp, &searchkey, FALSE, Irp);
         if (!NT_SUCCESS(Status)) {
-            ERR("open_fileref_by_inode returned %08x\n", Status);
-            free_fcb(fcb);
+            ERR("find_item returned %08x\n", Status);
+            free_fcb(Vcb, fcb);
+            if (hl_alloc) ExFreePool(name.Buffer);
             return Status;
         }
-    }
-    
-    fr = create_fileref();
-    if (!fr) {
-        ERR("out of memory\n");
-        free_fcb(fcb);
-        return STATUS_INSUFFICIENT_RESOURCES;
-    }
-    
-    fr->fcb = fcb;
-    fcb->fileref = fr;
-    
-    fr->index = hl->index;
-    
-    fr->utf8.Length = fr->utf8.MaximumLength = hl->utf8.Length;
-    if (fr->utf8.Length > 0) {
-        fr->utf8.Buffer = ExAllocatePoolWithTag(PagedPool, fr->utf8.Length, ALLOC_TAG);
-        
-        if (!fr->utf8.Buffer) {
-            ERR("out of memory\n");
-            free_fileref(fr);
-            return STATUS_INSUFFICIENT_RESOURCES;
+
+        if (tp.item->key.obj_id == searchkey.obj_id && tp.item->key.obj_type == searchkey.obj_type) {
+            ROOT_REF* rr = (ROOT_REF*)tp.item->data;
+            LIST_ENTRY* le;
+            root* r = NULL;
+            ULONG stringlen;
+
+            if (tp.item->size < sizeof(ROOT_REF)) {
+                ERR("(%llx,%x,%llx) was %u bytes, expected at least %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, sizeof(ROOT_REF));
+                free_fcb(Vcb, fcb);
+                if (hl_alloc) ExFreePool(name.Buffer);
+                return STATUS_INTERNAL_ERROR;
+            }
+
+            if (tp.item->size < offsetof(ROOT_REF, name[0]) + rr->n) {
+                ERR("(%llx,%x,%llx) was %u bytes, expected %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, offsetof(ROOT_REF, name[0]) + rr->n);
+                free_fcb(Vcb, fcb);
+                if (hl_alloc) ExFreePool(name.Buffer);
+                return STATUS_INTERNAL_ERROR;
+            }
+
+            le = Vcb->roots.Flink;
+            while (le != &Vcb->roots) {
+                root* r2 = CONTAINING_RECORD(le, root, list_entry);
+
+                if (r2->id == tp.item->key.offset) {
+                    r = r2;
+                    break;
+                }
+
+                le = le->Flink;
+            }
+
+            if (!r) {
+                ERR("couldn't find subvol %llx\n", tp.item->key.offset);
+                free_fcb(Vcb, fcb);
+                if (hl_alloc) ExFreePool(name.Buffer);
+                return STATUS_INTERNAL_ERROR;
+            }
+
+            Status = open_fileref_by_inode(Vcb, r, rr->dir, &parfr, Irp);
+            if (!NT_SUCCESS(Status)) {
+                ERR("open_fileref_by_inode returned %08x\n", Status);
+                free_fcb(Vcb, fcb);
+                if (hl_alloc) ExFreePool(name.Buffer);
+                return Status;
+            }
+
+            if (hl_alloc) {
+                ExFreePool(name.Buffer);
+                hl_alloc = FALSE;
+            }
+
+            Status = RtlUTF8ToUnicodeN(NULL, 0, &stringlen, rr->name, rr->n);
+            if (!NT_SUCCESS(Status)) {
+                ERR("RtlUTF8ToUnicodeN 1 returned %08x\n", Status);
+                free_fcb(Vcb, fcb);
+                return Status;
+            }
+
+            name.Length = name.MaximumLength = (UINT16)stringlen;
+
+            if (stringlen == 0)
+                name.Buffer = NULL;
+            else {
+                name.Buffer = ExAllocatePoolWithTag(PagedPool, name.MaximumLength, ALLOC_TAG);
+
+                if (!name.Buffer) {
+                    ERR("out of memory\n");
+                    free_fcb(Vcb, fcb);
+                    return STATUS_INSUFFICIENT_RESOURCES;
+                }
+
+                Status = RtlUTF8ToUnicodeN(name.Buffer, stringlen, &stringlen, rr->name, rr->n);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("RtlUTF8ToUnicodeN 2 returned %08x\n", Status);
+                    ExFreePool(name.Buffer);
+                    free_fcb(Vcb, fcb);
+                    return Status;
+                }
+
+                hl_alloc = TRUE;
+            }
+        } else {
+            ERR("couldn't find parent for subvol %llx\n", subvol->id);
+            free_fcb(Vcb, fcb);
+            if (hl_alloc) ExFreePool(name.Buffer);
+            return STATUS_INTERNAL_ERROR;
         }
-        
-        RtlCopyMemory(fr->utf8.Buffer, hl->utf8.Buffer, hl->utf8.Length);
-    }
-    
-    fr->filepart.MaximumLength = fr->filepart.Length = hl->name.Length;
-    
-    if (fr->filepart.Length > 0) {
-        fr->filepart.Buffer = ExAllocatePoolWithTag(PagedPool, fr->filepart.MaximumLength, ALLOC_TAG);
-        if (!fr->filepart.Buffer) {
-            ERR("out of memory\n");
-            free_fileref(fr);
-            return STATUS_INSUFFICIENT_RESOURCES;
+    } else {
+        Status = open_fileref_by_inode(Vcb, subvol, parent, &parfr, Irp);
+        if (!NT_SUCCESS(Status)) {
+            ERR("open_fileref_by_inode returned %08x\n", Status);
+            free_fcb(Vcb, fcb);
+
+            if (hl_alloc)
+                ExFreePool(name.Buffer);
+
+            return Status;
         }
-        
-        RtlCopyMemory(fr->filepart.Buffer, hl->name.Buffer, hl->name.Length);
     }
-    
-    Status = RtlUpcaseUnicodeString(&fr->filepart_uc, &fr->filepart, TRUE);
+
+    Status = open_fileref_child(Vcb, parfr, &name, TRUE, TRUE, FALSE, PagedPool, &fr, Irp);
+
     if (!NT_SUCCESS(Status)) {
-        ERR("RtlUpcaseUnicodeString returned %08x\n", Status);
-        free_fileref(fr);
+        ERR("open_fileref_child returned %08x\n", Status);
+
+        if (hl_alloc)
+            ExFreePool(name.Buffer);
+
+        free_fcb(Vcb, fcb);
+        free_fileref(Vcb, parfr);
+
         return Status;
     }
-    
-    fr->parent = parfr;
-    
-    Status = add_dir_child(parfr->fcb, fr->fcb->inode == SUBVOL_ROOT_INODE ? fr->fcb->subvol->id : fr->fcb->inode, fr->fcb->inode == SUBVOL_ROOT_INODE,
-                           fr->index, &fr->utf8, &fr->filepart, &fr->filepart_uc, fr->fcb->type, &dc);
-    if (!NT_SUCCESS(Status))
-        WARN("add_dir_child returned %08x\n", Status);
-    
-    fr->dc = dc;
-    dc->fileref = fr;
-    
-    insert_fileref_child(parfr, fr, TRUE);
 
     *pfr = fr;
-    
+
+    if (hl_alloc)
+        ExFreePool(name.Buffer);
+
+    free_fcb(Vcb, fcb);
+    free_fileref(Vcb, parfr);
+
     return STATUS_SUCCESS;
 }
 
 #ifndef __REACTOS__
-static NTSTATUS STDCALL fill_in_hard_link_information(FILE_LINKS_INFORMATION* fli, file_ref* fileref, PIRP Irp, LONG* length) {
+static NTSTATUS fill_in_hard_link_information(FILE_LINKS_INFORMATION* fli, file_ref* fileref, PIRP Irp, LONG* length) {
     NTSTATUS Status;
     LIST_ENTRY* le;
-    ULONG bytes_needed;
+    LONG bytes_needed;
     FILE_LINK_ENTRY_INFORMATION* feli;
     BOOL overflow = FALSE;
     fcb* fcb = fileref->fcb;
     ULONG len;
-    
+
     if (fcb->ads)
         return STATUS_INVALID_PARAMETER;
-    
-    if (*length < offsetof(FILE_LINKS_INFORMATION, Entry))
+
+    if (*length < (LONG)offsetof(FILE_LINKS_INFORMATION, Entry))
         return STATUS_INVALID_PARAMETER;
-    
+
     RtlZeroMemory(fli, *length);
-    
+
     bytes_needed = offsetof(FILE_LINKS_INFORMATION, Entry);
     len = bytes_needed;
     feli = NULL;
-    
+
     ExAcquireResourceSharedLite(fcb->Header.Resource, TRUE);
-    
+
     if (fcb->inode == SUBVOL_ROOT_INODE) {
         ULONG namelen;
-        
+
         if (fcb == fcb->Vcb->root_fileref->fcb)
             namelen = sizeof(WCHAR);
         else
-            namelen = fileref->filepart.Length;
-                    
+            namelen = fileref->dc->name.Length;
+
         bytes_needed += sizeof(FILE_LINK_ENTRY_INFORMATION) - sizeof(WCHAR) + namelen;
-        
+
         if (bytes_needed > *length)
             overflow = TRUE;
-        
+
         if (!overflow) {
             feli = &fli->Entry;
-                        
+
             feli->NextEntryOffset = 0;
             feli->ParentFileId = 0; // we use an inode of 0 to mean the parent of a subvolume
-            
+
             if (fcb == fcb->Vcb->root_fileref->fcb) {
                 feli->FileNameLength = 1;
                 feli->FileName[0] = '.';
             } else {
-                feli->FileNameLength = fileref->filepart.Length / sizeof(WCHAR);
-                RtlCopyMemory(feli->FileName, fileref->filepart.Buffer, fileref->filepart.Length);
+                feli->FileNameLength = fileref->dc->name.Length / sizeof(WCHAR);
+                RtlCopyMemory(feli->FileName, fileref->dc->name.Buffer, fileref->dc->name.Length);
             }
-            
+
             fli->EntriesReturned++;
-            
+
             len = bytes_needed;
         }
     } else {
         ExAcquireResourceExclusiveLite(&fcb->Vcb->fcb_lock, TRUE);
-    
+
         if (IsListEmpty(&fcb->hardlinks)) {
-            bytes_needed += sizeof(FILE_LINK_ENTRY_INFORMATION) + fileref->filepart.Length - sizeof(WCHAR);
-            
+            bytes_needed += sizeof(FILE_LINK_ENTRY_INFORMATION) + fileref->dc->name.Length - sizeof(WCHAR);
+
             if (bytes_needed > *length)
                 overflow = TRUE;
-            
+
             if (!overflow) {
                 feli = &fli->Entry;
 
                 feli->NextEntryOffset = 0;
                 feli->ParentFileId = fileref->parent->fcb->inode;
-                feli->FileNameLength = fileref->filepart.Length / sizeof(WCHAR);
-                RtlCopyMemory(feli->FileName, fileref->filepart.Buffer, fileref->filepart.Length);
-                
+                feli->FileNameLength = fileref->dc->name.Length / sizeof(WCHAR);
+                RtlCopyMemory(feli->FileName, fileref->dc->name.Buffer, fileref->dc->name.Length);
+
                 fli->EntriesReturned++;
-                
+
                 len = bytes_needed;
             }
         } else {
@@ -4011,83 +3497,83 @@
             while (le != &fcb->hardlinks) {
                 hardlink* hl = CONTAINING_RECORD(le, hardlink, list_entry);
                 file_ref* parfr;
-                
+
                 TRACE("parent %llx, index %llx, name %.*S\n", hl->parent, hl->index, hl->name.Length / sizeof(WCHAR), hl->name.Buffer);
-                
+
                 Status = open_fileref_by_inode(fcb->Vcb, fcb->subvol, hl->parent, &parfr, Irp);
-                
+
                 if (!NT_SUCCESS(Status)) {
                     ERR("open_fileref_by_inode returned %08x\n", Status);
                 } else if (!parfr->deleted) {
                     LIST_ENTRY* le2;
                     BOOL found = FALSE, deleted = FALSE;
-                    UNICODE_STRING* fn;
-                    
+                    UNICODE_STRING* fn = NULL;
+
                     le2 = parfr->children.Flink;
                     while (le2 != &parfr->children) {
                         file_ref* fr2 = CONTAINING_RECORD(le2, file_ref, list_entry);
-                        
-                        if (fr2->index == hl->index) {
+
+                        if (fr2->dc->index == hl->index) {
                             found = TRUE;
                             deleted = fr2->deleted;
-                            
+
                             if (!deleted)
-                                fn = &fr2->filepart;
-                            
+                                fn = &fr2->dc->name;
+
                             break;
                         }
-                        
+
                         le2 = le2->Flink;
                     }
-                    
+
                     if (!found)
                         fn = &hl->name;
-                    
+
                     if (!deleted) {
                         TRACE("fn = %.*S (found = %u)\n", fn->Length / sizeof(WCHAR), fn->Buffer, found);
-                        
+
                         if (feli)
-                            bytes_needed = sector_align(bytes_needed, 8);
-                        
+                            bytes_needed = (LONG)sector_align(bytes_needed, 8);
+
                         bytes_needed += sizeof(FILE_LINK_ENTRY_INFORMATION) + fn->Length - sizeof(WCHAR);
-                        
+
                         if (bytes_needed > *length)
                             overflow = TRUE;
-                        
+
                         if (!overflow) {
                             if (feli) {
-                                feli->NextEntryOffset = sector_align(sizeof(FILE_LINK_ENTRY_INFORMATION) + ((feli->FileNameLength - 1) * sizeof(WCHAR)), 8);
+                                feli->NextEntryOffset = (ULONG)sector_align(sizeof(FILE_LINK_ENTRY_INFORMATION) + ((feli->FileNameLength - 1) * sizeof(WCHAR)), 8);
                                 feli = (FILE_LINK_ENTRY_INFORMATION*)((UINT8*)feli + feli->NextEntryOffset);
                             } else
                                 feli = &fli->Entry;
-                            
+
                             feli->NextEntryOffset = 0;
                             feli->ParentFileId = parfr->fcb->inode;
                             feli->FileNameLength = fn->Length / sizeof(WCHAR);
                             RtlCopyMemory(feli->FileName, fn->Buffer, fn->Length);
-                            
+
                             fli->EntriesReturned++;
-                            
+
                             len = bytes_needed;
                         }
                     }
-                    
-                    free_fileref(parfr);
+
+                    free_fileref(fcb->Vcb, parfr);
                 }
-                
+
                 le = le->Flink;
             }
         }
-        
+
         ExReleaseResourceLite(&fcb->Vcb->fcb_lock);
     }
-    
+
     fli->BytesNeeded = bytes_needed;
-    
+
     *length -= len;
 
     Status = overflow ? STATUS_BUFFER_OVERFLOW : STATUS_SUCCESS;
-    
+
     ExReleaseResourceLite(fcb->Header.Resource);
 
     return Status;
@@ -4098,7 +3584,7 @@
 #ifdef __MINGW32__
 typedef struct _FILE_ID_128 {
     UCHAR Identifier[16];
-} FILE_ID_128, *PFILE_ID_128; 
+} FILE_ID_128, *PFILE_ID_128;
 
 typedef struct _FILE_ID_INFORMATION {
     ULONGLONG VolumeSerialNumber;
@@ -4110,14 +3596,14 @@
     RtlCopyMemory(&fii->VolumeSerialNumber, &fcb->Vcb->superblock.uuid.uuid[8], sizeof(UINT64));
     RtlCopyMemory(&fii->FileId.Identifier[0], &fcb->inode, sizeof(UINT64));
     RtlCopyMemory(&fii->FileId.Identifier[sizeof(UINT64)], &fcb->subvol->id, sizeof(UINT64));
-    
+
     *length -= sizeof(FILE_ID_INFORMATION);
-    
+
     return STATUS_SUCCESS;
 }
 #endif
 
-static NTSTATUS STDCALL query_info(device_extension* Vcb, PFILE_OBJECT FileObject, PIRP Irp) {
+static NTSTATUS query_info(device_extension* Vcb, PFILE_OBJECT FileObject, PIRP Irp) {
     PIO_STACK_LOCATION IrpSp = IoGetCurrentIrpStackLocation(Irp);
     LONG length = IrpSp->Parameters.QueryFile.Length;
     fcb* fcb = FileObject->FsContext;
@@ -4124,32 +3610,32 @@
     ccb* ccb = FileObject->FsContext2;
     file_ref* fileref = ccb ? ccb->fileref : NULL;
     NTSTATUS Status;
-    
+
     TRACE("(%p, %p, %p)\n", Vcb, FileObject, Irp);
     TRACE("fcb = %p\n", fcb);
-    
+
     if (fcb == Vcb->volume_fcb)
         return STATUS_INVALID_PARAMETER;
-    
+
     if (!ccb) {
         ERR("ccb is NULL\n");
         return STATUS_INVALID_PARAMETER;
     }
-    
+
     switch (IrpSp->Parameters.QueryFile.FileInformationClass) {
         case FileAllInformation:
         {
             FILE_ALL_INFORMATION* fai = Irp->AssociatedIrp.SystemBuffer;
             INODE_ITEM* ii;
-            
+
             TRACE("FileAllInformation\n");
-            
+
             if (Irp->RequestorMode != KernelMode && !(ccb->access & (FILE_READ_ATTRIBUTES | FILE_WRITE_ATTRIBUTES))) {
                 WARN("insufficient privileges\n");
                 Status = STATUS_ACCESS_DENIED;
                 goto exit;
             }
-            
+
             if (fcb->ads) {
                 if (!fileref || !fileref->parent) {
                     ERR("no fileref for stream\n");
@@ -4156,38 +3642,37 @@
                     Status = STATUS_INTERNAL_ERROR;
                     goto exit;
                 }
-                
+
                 ii = &fileref->parent->fcb->inode_item;
             } else
                 ii = &fcb->inode_item;
-            
+
+            // Access, mode, and alignment are all filled in by the kernel
+
             if (length > 0)
                 fill_in_file_basic_information(&fai->BasicInformation, ii, &length, fcb, fileref);
-            
+
             if (length > 0)
                 fill_in_file_standard_information(&fai->StandardInformation, fcb, fileref, &length);
-            
+
             if (length > 0)
                 fill_in_file_internal_information(&fai->InternalInformation, fcb, &length);
-            
+
             if (length > 0)
                 fill_in_file_ea_information(&fai->EaInformation, fcb, &length);
-            
+
+            length -= sizeof(FILE_ACCESS_INFORMATION);
+
             if (length > 0)
-                fill_in_file_access_information(&fai->AccessInformation, &length);
-            
-            if (length > 0)
                 fill_in_file_position_information(&fai->PositionInformation, FileObject, &length);
-                
+
+            length -= sizeof(FILE_MODE_INFORMATION);
+
+            length -= sizeof(FILE_ALIGNMENT_INFORMATION);
+
             if (length > 0)
-                fill_in_file_mode_information(&fai->ModeInformation, ccb, &length);
-            
-            if (length > 0)
-                fill_in_file_alignment_information(&fai->AlignmentInformation, Vcb, &length);
-            
-            if (length > 0)
                 fill_in_file_name_information(&fai->NameInformation, fcb, fileref, &length);
-            
+
             Status = STATUS_SUCCESS;
 
             break;
@@ -4196,17 +3681,19 @@
         case FileAttributeTagInformation:
         {
             FILE_ATTRIBUTE_TAG_INFORMATION* ati = Irp->AssociatedIrp.SystemBuffer;
-            
+
             TRACE("FileAttributeTagInformation\n");
-            
+
             if (Irp->RequestorMode != KernelMode && !(ccb->access & (FILE_READ_ATTRIBUTES | FILE_WRITE_ATTRIBUTES))) {
                 WARN("insufficient privileges\n");
                 Status = STATUS_ACCESS_DENIED;
                 goto exit;
             }
-            
-            Status = fill_in_file_attribute_information(ati, fcb, fileref, Irp, &length);
-            
+
+            ExAcquireResourceSharedLite(&Vcb->tree_lock, TRUE);
+            Status = fill_in_file_attribute_information(ati, fcb, ccb, Irp, &length);
+            ExReleaseResourceLite(&Vcb->tree_lock);
+
             break;
         }
 
@@ -4214,21 +3701,21 @@
         {
             FILE_BASIC_INFORMATION* fbi = Irp->AssociatedIrp.SystemBuffer;
             INODE_ITEM* ii;
-            
+
             TRACE("FileBasicInformation\n");
-            
+
             if (Irp->RequestorMode != KernelMode && !(ccb->access & (FILE_READ_ATTRIBUTES | FILE_WRITE_ATTRIBUTES))) {
                 WARN("insufficient privileges\n");
                 Status = STATUS_ACCESS_DENIED;
                 goto exit;
             }
-            
+
             if (IrpSp->Parameters.QueryFile.Length < sizeof(FILE_BASIC_INFORMATION)) {
                 WARN("overflow\n");
                 Status = STATUS_BUFFER_OVERFLOW;
                 goto exit;
             }
-            
+
             if (fcb->ads) {
                 if (!fileref || !fileref->parent) {
                     ERR("no fileref for stream\n");
@@ -4235,11 +3722,11 @@
                     Status = STATUS_INTERNAL_ERROR;
                     goto exit;
                 }
-                
+
                 ii = &fileref->parent->fcb->inode_item;
             } else
                 ii = &fcb->inode_item;
-            
+
             Status = fill_in_file_basic_information(fbi, ii, &length, fcb, fileref);
             break;
         }
@@ -4252,11 +3739,11 @@
         case FileEaInformation:
         {
             FILE_EA_INFORMATION* eai = Irp->AssociatedIrp.SystemBuffer;
-            
+
             TRACE("FileEaInformation\n");
-            
+
             Status = fill_in_file_ea_information(eai, fcb, &length);
-            
+
             break;
         }
 
@@ -4263,11 +3750,11 @@
         case FileInternalInformation:
         {
             FILE_INTERNAL_INFORMATION* fii = Irp->AssociatedIrp.SystemBuffer;
-            
+
             TRACE("FileInternalInformation\n");
-            
+
             Status = fill_in_file_internal_information(fii, fcb, &length);
-            
+
             break;
         }
 
@@ -4274,11 +3761,11 @@
         case FileNameInformation:
         {
             FILE_NAME_INFORMATION* fni = Irp->AssociatedIrp.SystemBuffer;
-            
+
             TRACE("FileNameInformation\n");
-            
+
             Status = fill_in_file_name_information(fni, fcb, fileref, &length);
-            
+
             break;
         }
 
@@ -4285,15 +3772,15 @@
         case FileNetworkOpenInformation:
         {
             FILE_NETWORK_OPEN_INFORMATION* fnoi = Irp->AssociatedIrp.SystemBuffer;
-            
+
             TRACE("FileNetworkOpenInformation\n");
-            
+
             if (Irp->RequestorMode != KernelMode && !(ccb->access & (FILE_READ_ATTRIBUTES | FILE_WRITE_ATTRIBUTES))) {
                 WARN("insufficient privileges\n");
                 Status = STATUS_ACCESS_DENIED;
                 goto exit;
             }
-            
+
             Status = fill_in_file_network_open_information(fnoi, fcb, fileref, &length);
 
             break;
@@ -4302,11 +3789,11 @@
         case FilePositionInformation:
         {
             FILE_POSITION_INFORMATION* fpi = Irp->AssociatedIrp.SystemBuffer;
-            
+
             TRACE("FilePositionInformation\n");
-            
+
             Status = fill_in_file_position_information(fpi, FileObject, &length);
-            
+
             break;
         }
 
@@ -4313,17 +3800,17 @@
         case FileStandardInformation:
         {
             FILE_STANDARD_INFORMATION* fsi = Irp->AssociatedIrp.SystemBuffer;
-            
+
             TRACE("FileStandardInformation\n");
-            
+
             if (IrpSp->Parameters.QueryFile.Length < sizeof(FILE_STANDARD_INFORMATION)) {
                 WARN("overflow\n");
                 Status = STATUS_BUFFER_OVERFLOW;
                 goto exit;
             }
-            
+
             Status = fill_in_file_standard_information(fsi, fcb, ccb->fileref, &length);
-            
+
             break;
         }
 
@@ -4330,11 +3817,11 @@
         case FileStreamInformation:
         {
             FILE_STREAM_INFORMATION* fsi = Irp->AssociatedIrp.SystemBuffer;
-            
+
             TRACE("FileStreamInformation\n");
-            
-            Status = fill_in_file_stream_information(fsi, fileref, Irp, &length);
 
+            Status = fill_in_file_stream_information(fsi, fileref, &length);
+
             break;
         }
 
